Status: Resolved Priority: Should have
Author: Alexander Stehlik Category:
Updated: 2015-04-27 Due date:
TYPO3 Version: 6.2
PHP Version: 5.5
Complexity:
Is Regression: No
Sprint Focus:
Subject: Using TYPO3_COMPOSER_AUTOLOAD requires post-autoload-dump script in project composer.json
Description

I tested the new class loading with TYPO3_COMPOSER_AUTOLOAD enabled.

Everything works fine, unless you do not have extensions that use legacy class names in their ext_localconf.php files. Those classes
will not be found.

What solved the problem for me was adding the post-autoload-dump setting the composer.json file of my project:

"scripts": {
    "post-autoload-dump": "Helhum\\ClassAliasLoader\\Composer\\ClassAliasGenerator::generateAliasMap" 
},

In my point of view it makes sense, that this script configuration needs to be added, otherwise the alias map will not be available in the
autoloader of composer.

But this should be documented.

Related issues:
related to Core - Task # 64361: Improve class loading performance Resolved 2015-01-19

Associated revisions
Revision 2a432333 - 2015-04-27 17:04 - Helmut Hummel

[BUGFIX] Simplify composer class alias loader usage

The class alias loader package was changed to be a composer plugin.
By that, the script section can be removed again.

In addition we change the requirement to the minimum version which
contains the plugin conversion.

Releases: 6.2, master
Resolves: #65688
Change-Id: I2ca1eee56e9a3f9e1f538ab95d9a01544ea98c95
Reviewed-on: http://review.typo3.org/38956
Reviewed-by: Helmut Hummel <helmut.hummel@typo3.org>
Tested-by: Helmut Hummel <helmut.hummel@typo3.org>
Revision 77ec9425 - 2015-04-27 17:04 - Helmut Hummel

[BUGFIX] Simplify composer class alias loader usage

The class alias loader package was changed to be a composer plugin.
By that, the script section can be removed again.

In addition we change the requirement to the minimum version which
contains the plugin conversion.

Releases: 6.2, master
Resolves: #65688
Change-Id: I2ca1eee56e9a3f9e1f538ab95d9a01544ea98c95
Reviewed-on: http://review.typo3.org/38955
Reviewed-by: Helmut Hummel <helmut.hummel@typo3.org>
Tested-by: Helmut Hummel <helmut.hummel@typo3.org>

History
#1 - 2015-03-23 15:46 - Fabien Udriot
- Description updated

+1

Thanks Alexander for posting your solution. I run into the same problem and adding the post-autoload-dump solved the case.

What the log was saying:

PHP Catchable fatal error:  Argument 1 passed to TYPO3\CMS\Core\Core\ClassAliasMap::injectComposerClassLoader() must be an 
instance of Helhum\ClassAliasLoader\Composer\ClassAliasLoader, instance of Composer\Autoload\ClassLoader given, called in 
/var/www/typo3_src/typo3/sysext/core/Classes/Core/Bootstrap.php on line 420 and defined in 
/var/www/typo3_src/typo3/sysext/core/Classes/Core/ClassAliasMap.php on line 87

#2 - 2015-04-27 15:04 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/38955

#3 - 2015-04-27 15:10 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/38956
#4 - 2015-04-27 16:52 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/38955

#5 - 2015-04-27 16:54 - Gerrit Code Review

Patch set 2 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/38956

#6 - 2015-04-27 17:30 - Helmut Hummel
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:2a4323338409667d3d6f51360093eb3dcee7591f.
